﻿param 
(
    $Server = "(local)",
    $Database = "FIMSynchronizationService"
)

Set-PSDebug -Strict:$true

$connection = New-Object System.Data.SqlClient.SqlConnection -ArgumentList "Server=$Server;Database=$Database;Trusted_Connection=True;"
$connection.Open()

$command = New-Object System.Data.SqlClient.SqlCommand
$command.Connection = $connection
$command.CommandText = @"
SELECT
	administrators_sid,
	operators_sid,
	account_joiners_sid,
	browse_sid,
	passwordset_sid
FROM
	mms_server_configuration
"@

$dataset = New-Object System.Data.DataSet
$dataAdapter = New-Object System.Data.SqlClient.SqlDataAdapter
$dataAdapter.SelectCommand = $command
[void]($dataAdapter.Fill($dataset))

$admins = $dataset.Tables[0].Rows[0].administrators_sid
$ops = $dataset.Tables[0].Rows[0].operators_sid
$joiners = $dataset.Tables[0].Rows[0].account_joiners_sid
$browsers = $dataset.Tables[0].Rows[0].browse_sid
$pwdSet = $dataset.Tables[0].Rows[0].passwordset_sid

$translated = @()

$psObj = New-Object PSObject
$psObj | Add-Member -MemberType NoteProperty -Name "Name" -Value "Administrators"
$psObj | Add-Member -MemberType NoteProperty -Name "Group" -Value ""
$psObj | Add-Member -MemberType NoteProperty -Name "SID" -Value ""

$sid = New-Object System.Security.Principal.SecurityIdentifier -ArgumentList $admins,0
$psObj.Sid = $sid.ToString()
$psObj.Group = $sid.Translate([System.Security.Principal.NTAccount])

$translated += $psObj

#MIMSyncOperators
$psObj = New-Object PSObject
$psObj | Add-Member -MemberType NoteProperty -Name "Name" -Value "Operators"
$psObj | Add-Member -MemberType NoteProperty -Name "Group" -Value ""
$psObj | Add-Member -MemberType NoteProperty -Name "SID" -Value ""

$sid = New-Object System.Security.Principal.SecurityIdentifier -ArgumentList $ops,0
$psObj.Sid = $sid.ToString()
$psObj.Group = $sid.Translate([System.Security.Principal.NTAccount])

$translated += $psObj

#MIMSyncJoiners
$psObj = New-Object PSObject
$psObj | Add-Member -MemberType NoteProperty -Name "Name" -Value "Joiners"
$psObj | Add-Member -MemberType NoteProperty -Name "Group" -Value ""
$psObj | Add-Member -MemberType NoteProperty -Name "SID" -Value ""

$sid = New-Object System.Security.Principal.SecurityIdentifier -ArgumentList $joiners,0
$psObj.Sid = $sid.ToString()
$psObj.Group = $sid.Translate([System.Security.Principal.NTAccount])

$translated += $psObj

#MIMSyncPasswordSet
$psObj = New-Object PSObject
$psObj | Add-Member -MemberType NoteProperty -Name "Name" -Value "PasswordSet"
$psObj | Add-Member -MemberType NoteProperty -Name "Group" -Value ""
$psObj | Add-Member -MemberType NoteProperty -Name "SID" -Value ""

$sid = New-Object System.Security.Principal.SecurityIdentifier -ArgumentList $pwdSet,0
$psObj.Sid = $sid.ToString()
$psObj.Group = $sid.Translate([System.Security.Principal.NTAccount])

$translated += $psObj

#MIMSyncBrowse
$psObj = New-Object PSObject
$psObj | Add-Member -MemberType NoteProperty -Name "Name" -Value "Browsers"
$psObj | Add-Member -MemberType NoteProperty -Name "Group" -Value ""
$psObj | Add-Member -MemberType NoteProperty -Name "SID" -Value ""

$sid = New-Object System.Security.Principal.SecurityIdentifier -ArgumentList $browsers,0
$psObj.Sid = $sid.ToString()
$psObj.Group = $sid.Translate([System.Security.Principal.NTAccount])

$translated += $psObj

$translated | sort Name | ft -AutoSize